var baseurl = "http://zhushou.huihui.cn/";
var URL_INSTALL = baseurl + 'installed?browser=sogou';
var URL_UPDATE = baseurl + 'updatelog?browser=sogou';  

var vendors_self = ["youdao", "chrome", "sogou", "firefox", "opera"];
var vendor = 'youdao';
if (vendor === '@' + 'vendor@') {
    vendor = 'youdao';
}
var b_self = false;


for (var o in vendors_self) {
    if (vendors_self[o] === vendor) {
        b_self = true;
    }
}
var vendor_prev = get('vendor');
if (!vendor_prev || !b_self) {
    set('vendor', vendor);
}


/* JS Option String Object */
function StrOpt(optstr) {
    if (!optstr) optstr = "";
    var argstrs = optstr.split(';');
    for (var i = 0; i < argstrs.length; ++i) {
        var pos = argstrs[i].search('=');
        if (pos != -1) {
            var name = argstrs[i].substring(0, pos);
            var value = argstrs[i].substr(pos+1);
            this[name] = value;
        }
    }
}

StrOpt.prototype.toOptString = function() {
    var str = "";
    for (var name in this) {
        if (isFunction(this[name])) continue;
        str += name + "=" + this[name] + ";";
    }
    return str;
};


// just for the the sogouExplorer
var currVersion = '3.0';
var prevVersion = get('version');
set('version', currVersion);

if (currVersion != prevVersion) {
    if (typeof prevVersion == 'undefined') {
        onInstall();
        } else {
        onUpdate();
    }  
}

/* 检查js选项字符串 */
(function checkOptionStr() {
    var o = new StrOpt(get('youdaoGWZS_jsOptions'));
    o["browser"] = "sogou";
    o["vendor"] = vendor;
    o["version"] = get('version');
    o["extensionid"] = get('guid');
    o["apiVersion"] = '2.5';
    set('youdaoGWZS_jsOptions', o.toOptString());
})();


(function sendHeartBeat() {
    var last = get('lastheartbeat');
    var today = (new Date).getDate();
    if (last && last == today) return;
    var version = currVersion;
    var guid = get('guid');
    if (!guid || guid === '') {
        guid = "";
        for (var i = 1; i <= 32; ++i) {
            var n = Math.floor(Math.random()*16.0).toString(16);
            guid += n;
            if((i==8)||(i==12)||(i==16)||(i==20))
            guid += "-";
        }
        set('guid', guid);
    }
    var url = baseurl + 'log?' + 
    'type=ARMANI_EXTENSION_HEARTBEAT' + 
    '&browser=sogou&extensionid=' + guid + 
    '&vendor=' + vendor + '&version=' + version;
    var img = new Image();
    img.src = url;
    set('lastheartbeat', today);
})();


/* 读取商家列表 */
(function updateConfig() {
    /* step 1: 先从本地xml文件更新 */
    if (!get('mre_txt')) {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', sogouExplorer.extension.getURL('config.xml'), false);
        xhr.send(null);
        parseConfigXML(xhr.responseXML.documentElement);
    }

    /* step 2: 每天从服务器更新一次 */
    var last = get('last_update_hour');
    var now = (new Date).getHours();
    if (!last || last != now) {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', baseurl + 'extensions/config.xml', true);
        xhr.onreadystatechange = function() {
            if (xhr.readyState == 4 && xhr.status == 200) {
                parseConfigXML(xhr.responseXML.documentElement);
                set('last_update_hour', now);
            } 
        }
        xhr.send(null);
    }
})();



sogouExplorer.extension.onRequest.addListener(function(request, sender, sendResponse) {
    switch (request.type) {
        case 'info':
        sendResponse({
            vendor: get('vendor'), 
            version: get('version'),
            option: get('youdaoGWZS_jsOptions'),
            matched: get('mre_txt'),
            blocked: get('bre_txt'),
            conf: get('parse_conf')
        });
        break;
        case 'setOptions':
        set('youdaoGWZS_jsOptions', request.optionstr);
        break;
        default: 
        sendResponese({});
        break;
    }
});

//open introduction page when install  
function onInstall() {
    var o = new StrOpt(get("youdaoGWZS_jsOptions"));
    o["state"] = "install";
    set("youdaoGWZS_jsOptions", o.toOptString());
    sogouExplorer.tabs.create({
        selected: true, 
        url: URL_INSTALL + '&version=' + get('version')+
        '&vendor=' + get('vendor')
    });
}

//open introduction page when major update
function onUpdate() {
    var o = new StrOpt(get("youdaoGWZS_jsOptions"));
    o["state"] = "update";
    set("youdaoGWZS_jsOptions", o.toOptString());
    sogouExplorer.tabs.create({
        selected: true, 
        url: URL_UPDATE + '&version=' + get('version') + 
        '&vendor=' + get('vendor')
    });
}

function parseConfigXML(doc) {
    if (!doc) return;
    
    var b = doc.getElementsByTagName("blocked")[0];
    var bre = b.lastChild.nodeValue;
    if (bre) set('bre_txt', bre);
    
    var m = doc.getElementsByTagName("matched")[0];
    var mre = m.lastChild.nodeValue;
    if (mre) set('mre_txt', mre);

    var c = doc.getElementsByTagName("conf")[0];
    var conf = c.lastChild.nodeValue;
    if (conf) set('parse_conf', conf);
}

function isFunction(obj) {
    var getType = {};
    return obj && getType.toString.call(obj) == '[object Function]';
}

function get(key) {
    return localStorage[key];
}

function set(key, val) {
    localStorage[key] = val;
}    
